#if !defined(CXCW_H)
#define CXCW_H

#if defined(__COMPILER_KCC__)
#define HAVE_SHORT_NAMES	1
#endif

#if defined(HAVE_SHORT_NAMES)
#define __STDC_VERSION__	0	/* to eliminate compiler warnings */
#include <shrtcw.h>
#endif /* defined(HAVE_SHORT_NAMES) */

#include <deccw.h>

#undef CMPLX
#define CMPLX(x,y) ((x) + I * (y)) /* constructor (like Fortran cmplx(x,y)) */

#define CXADDI_(result,z,y)	CXSET_(result, CXREAL_(z), CXIMAG_(z) + (y))
#define CXADDR_(result,z,x)	CXSET_(result, CXREAL_(z) + (x), CXIMAG_(z))
#define CXADD_(result,w,z)	CXSET_(result, CXREAL_(w) + CXREAL_(z), CXIMAG_(w) + CXIMAG_(z))
#define CXCONJ_(result,z)	CXSET_(result, CXREAL_(z), -CXIMAG_(z))
#define CXCOPY_(result,z)	CXSET_(result, CXREAL_(z), CXIMAG_(z))
#define CXHALF1NORM_(z)		((HALF * QABS(CXREAL_(z))) + (HALF * QABS(CXIMAG_(z))))
#define CXIMAG_(z)		(z)[1]
#define CXMULBYI_(result,z)	do { fp_cx_t tmp_; CXCOPY_(tmp_, z); CXSET_(result, -CXIMAG_(tmp_), CXREAL_(tmp_)); } while (0)
#define CXNEG_(result,z)	CXSET(result, -CXREAL_(z), -CXIMAG_(z))
#define CXREAL_(z)		(z)[0]
#define CXSCALE_(result,z,s)	CXSET_(result, CXREAL_(z) * (s), CXIMAG_(z) * (s))
#define CXSET_(result,x,y)	(CXREAL_(result) = (x), CXIMAG_(result) = (y))
#define CXSUBI_(result,w,y)	CXSET_(result, CXREAL_(w), CXIMAG_(w) - (y))
#define CXSUBR_(result,w,x)	CXSET_(result, CXREAL_(w) - (x), CXIMAG_(w))
#define CXSUB_(result,w,z)	CXSET_(result, CXREAL_(w) - CXREAL_(z), CXIMAG_(w) - CXIMAG_(z))

#if 0
/* gcc generates multiply instructions that lose sign of zero on AMD64, sigh... */
#define CXTOC_(z)		CMPLX(CXREAL_(z), CXIMAG_(z))
#else
/* exploit storage order requirement to convert with just a type cast */
#define CXTOC_(z)		(*(fp_c_t *)(&(CXREAL_(z))))
#endif

#if defined(__cplusplus)
extern "C" {
#endif

typedef float cx_float[2];
typedef double cx_double[2];
typedef decimal_float cx_decimal_float[2];
typedef decimal_double cx_decimal_double[2];

extern int (iscxinff) (const cx_float);
extern int (iscxnanf) (const cx_float);

extern float (cxabsf)	(const cx_float);
extern float (cxargf)	(const cx_float);
extern float (cximagf)	(const cx_float);
extern float (cxrealf)	(const cx_float);

extern void (cxacosf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxacoshf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxaddf)	(/*@out@*/ cx_float, const cx_float, const cx_float);
extern void (cxasinf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxasinhf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxatanf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxatanhf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxcbrtf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxconjf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxcopyf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxcosf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxcoshf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxdivf)	(/*@out@*/ cx_float, const cx_float, const cx_float);
extern void (cxexpf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxexpm1f)	(/*@out@*/ cx_float, const cx_float);
extern void (cxipowf)	(/*@out@*/ cx_float, const cx_float, int);
extern void (cxlogf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxlog1pf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxmulf)	(/*@out@*/ cx_float, const cx_float, const cx_float);
extern void (cxnegf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxpowf)	(/*@out@*/ cx_float, const cx_float, const cx_float);
extern void (cxprojf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxsetf)	(/*@out@*/ cx_float, float, float);
extern void (cxsinf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxsinhf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxsqrtf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxsubf)	(/*@out@*/ cx_float, const cx_float, const cx_float);
extern void (cxtanf)	(/*@out@*/ cx_float, const cx_float);
extern void (cxtanhf)	(/*@out@*/ cx_float, const cx_float);

extern int (iscxinf) (const cx_double);
extern int (iscxnan) (const cx_double);

extern double (cxabs)	(const cx_double);
extern double (cxarg)	(const cx_double);
extern double (cximag)	(const cx_double);
extern double (cxreal)	(const cx_double);

extern void (cxacos)	(/*@out@*/ cx_double, const cx_double);
extern void (cxacosh)	(/*@out@*/ cx_double, const cx_double);
extern void (cxadd)	(/*@out@*/ cx_double, const cx_double, const cx_double);
extern void (cxasin)	(/*@out@*/ cx_double, const cx_double);
extern void (cxasinh)	(/*@out@*/ cx_double, const cx_double);
extern void (cxatan)	(/*@out@*/ cx_double, const cx_double);
extern void (cxatanh)	(/*@out@*/ cx_double, const cx_double);
extern void (cxcbrt)	(/*@out@*/ cx_double, const cx_double);
extern void (cxconj)	(/*@out@*/ cx_double, const cx_double);
extern void (cxcopy)	(/*@out@*/ cx_double, const cx_double);
extern void (cxcos)	(/*@out@*/ cx_double, const cx_double);
extern void (cxcosh)	(/*@out@*/ cx_double, const cx_double);
extern void (cxdiv)	(/*@out@*/ cx_double, const cx_double, const cx_double);
extern void (cxexp)	(/*@out@*/ cx_double, const cx_double);
extern void (cxexpm1)	(/*@out@*/ cx_double, const cx_double);
extern void (cxipow)	(/*@out@*/ cx_double, const cx_double, int);
extern void (cxlog)	(/*@out@*/ cx_double, const cx_double);
extern void (cxlog1p)	(/*@out@*/ cx_double, const cx_double);
extern void (cxmul)	(/*@out@*/ cx_double, const cx_double, const cx_double);
extern void (cxneg)	(/*@out@*/ cx_double, const cx_double);
extern void (cxpow)	(/*@out@*/ cx_double, const cx_double, const cx_double);
extern void (cxproj)	(/*@out@*/ cx_double, const cx_double);
extern void (cxset)	(/*@out@*/ cx_double, double, double);
extern void (cxsin)	(/*@out@*/ cx_double, const cx_double);
extern void (cxsinh)	(/*@out@*/ cx_double, const cx_double);
extern void (cxsqrt)	(/*@out@*/ cx_double, const cx_double);
extern void (cxsub)	(/*@out@*/ cx_double, const cx_double, const cx_double);
extern void (cxtan)	(/*@out@*/ cx_double, const cx_double);
extern void (cxtanh)	(/*@out@*/ cx_double, const cx_double);

#if defined(HAVE_LONG_DOUBLE)

typedef long double cx_long_double[2];

extern int (iscxinfl) (const cx_long_double);
extern int (iscxnanl) (const cx_long_double);

extern long double (cxabsl)	(const cx_long_double);
extern long double (cxargl)	(const cx_long_double);
extern long double (cximagl)	(const cx_long_double);
extern long double (cxreall)	(const cx_long_double);

extern void (cxacoshl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxacosl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxaddl)	(/*@out@*/ cx_long_double, const cx_long_double, const cx_long_double);
extern void (cxasinhl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxasinl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxatanhl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxcbrtl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxatanl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxconjl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxcopyl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxcoshl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxcosl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxdivl)	(/*@out@*/ cx_long_double, const cx_long_double, const cx_long_double);
extern void (cxexpl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxexpm1l)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxipowl)	(/*@out@*/ cx_long_double, const cx_long_double, int);
extern void (cxlogl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxlog1pl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxmull)	(/*@out@*/ cx_long_double, const cx_long_double, const cx_long_double);
extern void (cxnegl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxpowl)	(/*@out@*/ cx_long_double, const cx_long_double, const cx_long_double);
extern void (cxprojl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxsetl)	(/*@out@*/ cx_long_double, long double, long double);
extern void (cxsinhl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxsinl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxsqrtl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxsubl)	(/*@out@*/ cx_long_double, const cx_long_double, const cx_long_double);
extern void (cxtanhl)	(/*@out@*/ cx_long_double, const cx_long_double);
extern void (cxtanl)	(/*@out@*/ cx_long_double, const cx_long_double);

#endif /* defined(HAVE_LONG_DOUBLE) */

#if defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES)

/* NB: _FPWIDETYPES is set by the HP-UX IA-64 compilers in response to
   the -fpwidetypes command-line option */

/* Mimic the HP-UX practice in <float.h>, <math.h>, and <stdlib.h> of
   providing typedefs of the user types extended and quad if they are
   not yet defined. */

#ifndef _INCLUDE_QUAD
typedef __float128 quad;
#define _INCLUDE_QUAD
#endif

#ifndef _INCLUDE_EXTENDED
typedef __float80 extended;
#define _INCLUDE_EXTENDED
#endif

typedef __float80 cx_float80[2];
typedef __float128 cx_float128[2];

extern int (iscxinfw) (const cx_float80);
extern int (iscxnanw) (const cx_float80);

extern __float80 (cxabsw)	(const cx_float80);
extern __float80 (cxargw)	(const cx_float80);
extern __float80 (cximagw)	(const cx_float80);
extern __float80 (cxrealw)	(const cx_float80);

extern void (cxacoshw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxacosw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxaddw)	(/*@out@*/ cx_float80, const cx_float80, const cx_float80);
extern void (cxasinhw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxasinw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxatanhw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxcbrtw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxatanw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxconjw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxcopyw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxcoshw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxcosw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxdivw)	(/*@out@*/ cx_float80, const cx_float80, const cx_float80);
extern void (cxexpw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxexpm1w)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxipoww)	(/*@out@*/ cx_float80, const cx_float80, int);
extern void (cxlogw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxlog1pw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxmulw)	(/*@out@*/ cx_float80, const cx_float80, const cx_float80);
extern void (cxnegw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxpoww)	(/*@out@*/ cx_float80, const cx_float80, const cx_float80);
extern void (cxprojw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxsetw)	(/*@out@*/ cx_float80, __float80, __float80);
extern void (cxsinhw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxsinw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxsqrtw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxsubw)	(/*@out@*/ cx_float80, const cx_float80, const cx_float80);
extern void (cxtanhw)	(/*@out@*/ cx_float80, const cx_float80);
extern void (cxtanw)	(/*@out@*/ cx_float80, const cx_float80);

extern int (iscxinfq) (const cx_float128);
extern int (iscxnanq) (const cx_float128);

extern __float128 (cxabsq)	(const cx_float128);
extern __float128 (cxargq)	(const cx_float128);
extern __float128 (cximagq)	(const cx_float128);
extern __float128 (cxrealq)	(const cx_float128);

extern void (cxacoshq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxacosq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxaddq)	(/*@out@*/ cx_float128, const cx_float128, const cx_float128);
extern void (cxasinhq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxasinq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxatanhq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxcbrtq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxatanq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxconjq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxcopyq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxcoshq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxcosq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxdivq)	(/*@out@*/ cx_float128, const cx_float128, const cx_float128);
extern void (cxexpq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxexpm1q)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxipowq)	(/*@out@*/ cx_float128, const cx_float128, int);
extern void (cxlogq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxlog1pq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxmulq)	(/*@out@*/ cx_float128, const cx_float128, const cx_float128);
extern void (cxnegq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxpowq)	(/*@out@*/ cx_float128, const cx_float128, const cx_float128);
extern void (cxprojq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxsetq)	(/*@out@*/ cx_float128, __float128, __float128);
extern void (cxsinhq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxsinq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxsqrtq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxsubq)	(/*@out@*/ cx_float128, const cx_float128, const cx_float128);
extern void (cxtanhq)	(/*@out@*/ cx_float128, const cx_float128);
extern void (cxtanq)	(/*@out@*/ cx_float128, const cx_float128);

#endif /* defined(__ia64) && defined(__hpux) && defined(_FPWIDETYPES) */

#if defined(HAVE_LONG_LONG_DOUBLE)

typedef long_long_double cx_long_long_double[2];

extern int (iscxinfll) (const cx_long_long_double);
extern int (iscxnanll) (const cx_long_long_double);

extern long_long_double (cxabsll)	(const cx_long_long_double);
extern long_long_double (cxargll)	(const cx_long_long_double);
extern long_long_double (cximagll)	(const cx_long_long_double);
extern long_long_double (cxrealll)	(const cx_long_long_double);

extern void (cxacoshll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxacosll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxaddll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double, const cx_long_long_double);
extern void (cxasinhll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxasinll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxatanhll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxcbrtll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxatanll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxconjll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxcopyll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxcoshll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxcosll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxdivll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double, const cx_long_long_double);
extern void (cxexpll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxexpm1ll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxipowll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double, int);
extern void (cxlogll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxlog1pll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxmulll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double, const cx_long_long_double);
extern void (cxnegll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxpowll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double, const cx_long_long_double);
extern void (cxprojll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxsetll)	(/*@out@*/ cx_long_long_double, long_long_double, long_long_double);
extern void (cxsinhll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxsinll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxsqrtll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxsubll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double, const cx_long_long_double);
extern void (cxtanhll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);
extern void (cxtanll)	(/*@out@*/ cx_long_long_double, const cx_long_long_double);

#endif /* defined(HAVE_LONG_LONG_DOUBLE) */

#if defined(HAVE_DECIMAL)

extern int (iscxinfdf) (const cx_decimal_float);
extern int (iscxnandf) (const cx_decimal_float);

extern decimal_float (cxabsdf)	(const cx_decimal_float);
extern decimal_float (cxargdf)	(const cx_decimal_float);
extern decimal_float (cximagdf)	(const cx_decimal_float);
extern decimal_float (cxrealdf)	(const cx_decimal_float);

extern void (cxacosdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxacoshdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxadddf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float, const cx_decimal_float);
extern void (cxasindf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxasinhdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxatandf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxatanhdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxcbrtdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxconjdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxcopydf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxcosdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxcoshdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxdivdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float, const cx_decimal_float);
extern void (cxexpdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxexpm1df)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxipowdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float, int);
extern void (cxlogdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxlog1pdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxmuldf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float, const cx_decimal_float);
extern void (cxnegdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxpowdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float, const cx_decimal_float);
extern void (cxprojdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxsetdf)	(/*@out@*/ cx_decimal_float, decimal_float, decimal_float);
extern void (cxsindf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxsinhdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxsqrtdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxsubdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float, const cx_decimal_float);
extern void (cxtandf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);
extern void (cxtanhdf)	(/*@out@*/ cx_decimal_float, const cx_decimal_float);

extern int (iscxinfd) (const cx_decimal_double);
extern int (iscxnand) (const cx_decimal_double);

extern decimal_double (cxabsd)	(const cx_decimal_double);
extern decimal_double (cxargd)	(const cx_decimal_double);
extern decimal_double (cximagd)	(const cx_decimal_double);
extern decimal_double (cxreald)	(const cx_decimal_double);

extern void (cxacosd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxacoshd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxaddd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double, const cx_decimal_double);
extern void (cxasind)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxasinhd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxatand)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxatanhd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxcbrtd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxconjd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxcopyd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxcosd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxcoshd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxdivd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double, const cx_decimal_double);
extern void (cxexpd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxexpm1d)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxipowd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double, int);
extern void (cxlogd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxlog1pd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxmuld)	(/*@out@*/ cx_decimal_double, const cx_decimal_double, const cx_decimal_double);
extern void (cxnegd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxpowd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double, const cx_decimal_double);
extern void (cxprojd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxsetd)	(/*@out@*/ cx_decimal_double, decimal_double, decimal_double);
extern void (cxsind)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxsinhd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxsqrtd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxsubd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double, const cx_decimal_double);
extern void (cxtand)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);
extern void (cxtanhd)	(/*@out@*/ cx_decimal_double, const cx_decimal_double);

#if defined(HAVE_DECIMAL_LONG_DOUBLE)

typedef decimal_long_double cx_decimal_long_double[2];

extern int (iscxinfdl) (const cx_decimal_long_double);
extern int (iscxnandl) (const cx_decimal_long_double);

extern decimal_long_double (cxabsdl)	(const cx_decimal_long_double);
extern decimal_long_double (cxargdl)	(const cx_decimal_long_double);
extern decimal_long_double (cximagdl)	(const cx_decimal_long_double);
extern decimal_long_double (cxrealdl)	(const cx_decimal_long_double);

extern void (cxacosdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxacoshdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxadddl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxasindl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxasinhdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxatandl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxatanhdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxcbrtdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxconjdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxcopydl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxcosdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxcoshdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxdivdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxexpdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxexpm1dl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxipowdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double, int);
extern void (cxlogdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxlog1pdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxmuldl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxnegdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxpowdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxprojdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxsetdl)	(/*@out@*/ cx_decimal_long_double, decimal_long_double, decimal_long_double);
extern void (cxsindl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxsinhdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxsqrtdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxsubdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxtandl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);
extern void (cxtanhdl)	(/*@out@*/ cx_decimal_long_double, const cx_decimal_long_double);

#endif /* defined(HAVE_DECIMAL_LONG_DOUBLE) */

#if defined(HAVE_DECIMAL_LONG_LONG_DOUBLE)

typedef decimal_long_long_double cx_decimal_long_long_double[2];

extern int (iscxinfdll) (const cx_decimal_long_long_double);
extern int (iscxnandll) (const cx_decimal_long_long_double);

extern decimal_long_long_double (cxabsdll)	(const cx_decimal_long_long_double);
extern decimal_long_long_double (cxargdll)	(const cx_decimal_long_long_double);
extern decimal_long_long_double (cximagdll)	(const cx_decimal_long_long_double);
extern decimal_long_long_double (cxrealdll)	(const cx_decimal_long_long_double);

extern void (cxacosdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxacoshdll)	(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxadddll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxasindll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxasinhdll)	(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxatandll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxatanhdll)	(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxcbrtdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxconjdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxcopydll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxcosdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxcoshdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxdivdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxexpdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxexpm1dll)	(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxipowdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double, int);
extern void (cxlogdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxlog1pdll)	(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxmuldll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxnegdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxpowdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxprojdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxsetdll)		(/*@out@*/ cx_decimal_long_long_double, decimal_long_long_double, decimal_long_long_double);
extern void (cxsindll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxsinhdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxsqrtdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxsubdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxtandll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);
extern void (cxtanhdll)		(/*@out@*/ cx_decimal_long_long_double, const cx_decimal_long_long_double);

#endif /* defined(HAVE_DECIMAL_LONG_LONG_DOUBLE) */

#endif /* defined(HAVE_DECIMAL) */

#if defined(__cplusplus)
}
#endif

#endif /* !defined(CXCW_H) */
